// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.


import HTTP

public extension Bot {

    /// Parameters container struct for `setStickerPositionInSet` method
    public struct SetStickerPositionInSetParams: JSONEncodable {

        /// File identifier of the sticker
        var sticker: String

        /// New sticker position in the set, zero-based
        var position: Int

        /// Custom keys for coding/decoding `SetStickerPositionInSetParams` struct
        enum CodingKeys: String, CodingKey {
            case sticker = "sticker"
            case position = "position"
        }

        public init(sticker: String, position: Int) {
            self.sticker = sticker
            self.position = position
        }
    }

    /**
     Use this method to move a sticker in a set created by the bot to a specific position . Returns True on success.

     SeeAlso Telegram Bot API Reference:
     [SetStickerPositionInSetParams](https://core.telegram.org/bots/api#setstickerpositioninset)
     
     - Parameters:
         - params: Parameters container, see `SetStickerPositionInSetParams` struct
     - Throws: Throws on errors
     - Returns: Future of `Bool` type
     */
    @discardableResult
    public func setStickerPositionInSet(params: SetStickerPositionInSetParams) throws -> Future<Bool> {
        let body = try httpBody(for: params)
        let headers = httpHeaders(for: params)
        let response: Future<TelegramContainer<Bool>>
        response = try client.respond(endpoint: "setStickerPositionInSet", body: body, headers: headers)
        return response.flatMap(to: Bool.self) { try self.wrap($0) }
    }
}
